#include <sys/region.h>
#include "actmgr.h"

void actmgrConstruct(ActMgr* actmgr) {

	vec_Construct(&actmgr->actions, sizeof(Action*), ALIGN_DEFAULT);
}

void actmgrAddAction(ActMgr* actmgr, Action* action) {

	Action** a = vec_GetElement(&actmgr->actions, 0);
	uint32_t i = vec_GetSize(&actmgr->actions);

	while(i) {
		--i;
		if(*a) {
			++a;
		} else {
			*a = action;
			break;
		}
	}

	if(0 == i) {
		vec_PushBack(&actmgr->actions, &action);
	}
}

void actmgrProcess(ActMgr* actmgr, Time time) {

	static Time timeInf = {0,0,0};

	Action** action = vec_GetElement(&actmgr->actions, 0);
	uint32_t i = vec_GetSize(&actmgr->actions);

	while(i--) {
		if(NULL != *action && TIME_LESS != timeCompare(time, (*action)->timeStart)) {
			if(TIME_EQUAL == timeCompare((*action)->timeDuration, timeInf)
			|| TIME_LESS == timeCompare(timeDuration((*action)->timeStart, time), (*action)->timeDuration)) {
				(*action)->f(timeDuration((*action)->timeStart, time), (*action)->arg);
			} else {
				actmgrDetachAction(actmgr, (*action)->f);
			}
		}
		++action;
	}
}

void actmgrDetachAction(ActMgr* actmgr, actionf function) {

	Action** action = vec_GetElement(&actmgr->actions, 0);
	uint32_t i = vec_GetSize(&actmgr->actions);

	while(i--) {
		if(function == (*action)->f) {
			(*action)->f = NULL;
			break;
		}
		++action;
	}
}

