#include <abort.h>
#include <malloc.h>
#include <string.h>
#include "pair_.h"

Pair_* pair_New(size_t keysize, size_t valuesize, void* key) {

	Pair_* pair = malloc(sizeof(Pair_));
	if(NULL == pair)
		abort();
	pair_Construct(pair, keysize, valuesize, key);
	return pair;
}

void pair_Delete(Pair_* pair) {

	pair_Destroy(pair);
	free(pair);
}
void pair_Construct(Pair_* pair, size_t keysize, size_t valuesize, void* key) {

	pair->key = malloc(keysize);
	if(NULL == pair)
		abort();
	vec_Construct(&pair->vals, valuesize, 0);
	memcpy(pair->key, key, keysize);
}

void pair_Destroy(Pair_* pair) {

	free(pair->key);
	vec_Destroy(&pair->vals);
}

