#ifndef STACK_H
#define STACK_H

#include <containers/vec_.h>
#include <types.h>

typedef struct {
	size_t	el_size;
	uint_t	el_pushed;
	Vec_	data;
} Stack;

void stackConstruct(Stack* stack, size_t el_size);
void stackDestroy(Stack* stack);
void stackPush(Stack* stack, void* element);
void* stackPop(Stack* stack);
void* stackGet(Stack* stack, uint_t i);
bool stackIsEmpty(const Stack* stack);

#endif	/* STACK_H */

