#ifndef VEC__H
#define VEC__H

#include <types.h>

typedef struct {
	uint32_t	num_el;
	uint32_t	max_el;
	size_t		el_size;
	size_t		alignment;
	void*		data_unaligned;
	void*		data;
	void*		end;
} Vec_;

Vec_* vec_New(size_t el_size, size_t alignment);
void vec_Delete(Vec_* vec);
void vec_Construct(Vec_* vec, size_t el_size, size_t alignment);
void vec_Destroy(Vec_* vec);
void vec_Resize(Vec_* vec, uint32_t newsize);
void vec_PushBack(Vec_* vec, const void* element);
void* vec_GetElement(Vec_* vec, uint32_t i);
void* vec_GetTail(Vec_* vec);
const void* vec_GetConstElement(const Vec_* vec, uint32_t i);
uint32_t vec_GetSize(const Vec_* vec);
void vec_Reset(Vec_* vec);

#endif	/* VEC__H */
