#ifndef DLTRANS_H
#define DLTRANS_H

#include <containers/vec_.h>
#include <math/vector.h>
#include <sys/dlist.h>
#include <sys/displaylist.h>
#include <sys/surface.h>
#include <texture.h>
#include <types.h>

typedef struct {
	Vec_		vtxBuffer;
	uint32_t*	idxBuffer;
	uint8_t		vtxFormat;
	void*		vtxSource;
	void*		idxSource;
	float		scale;
	Surface		surfColor;
	Surface		surfZ;
	Vector4f	clearColor;
	float		clearZVal;
	Texture		tex;
} DLTrans;

void dltransConstruct(DLTrans* dltrans);
void dltransDestroy(DLTrans* dltrans);
void dltransSetScale(DLTrans* dltrans, float scale);
void dltransProcess(DLTrans* dltrans, const DList* dl_in, DisplayList* dl_out, size_t* dl_out_size, void** data_out, size_t* data_out_size);

#endif	/* DLTRANS_H */

