#include "gpu.h"
#include "dltrans.h"

void gpuConstruct(GPU* gpu) {

	vpuConstruct(&gpu->vpu);
	ppuConstruct(&gpu->ppu);
}

void gpuDestroy(GPU* gpu) {

	ppuDestroy(&gpu->ppu);
	vpuDestroy(&gpu->vpu);
}

void gpuProcess(GPU* gpu, DList* dlist) {

	if(gpu) {}
	if(dlist) {}
}

inline const VPU* gpuGetVPU(const GPU* gpu) {

	return &gpu->vpu;
}

inline const PPU* gpuGetPPU(const GPU* gpu) {

	return &gpu->ppu;
}

inline bool gpuIsBusy(const GPU* gpu) {

	return vpuIsBusy(gpuGetVPU(gpu)) || ppuIsBusy(gpuGetPPU(gpu));
}

