#ifndef GPU_H
#define GPU_H

#include <ultra64.h>
#include <types.h>
#include "sys/dlist.h"
#include "vpu.h"
#include "ppu.h"

typedef struct {
	VPU	vpu;
	PPU	ppu;
} GPU;

void gpuConstruct(GPU* gpu);
void gpuDestroy(GPU* gpu);
void gpuProcess(GPU* gpu, DList* dlist);
const VPU* gpuGetVPU(const GPU* gpu);
const PPU* gpuGetPPU(const GPU* gpu);
bool gpuIsBusy(const GPU* gpu);

#endif	/* GPU_H */

