#ifndef MATRIX_H
#define MATRIX_H

typedef float	Matrix[4][4];

void matrixIdentity(Matrix* mtx);
void matrixRotate(Matrix* mtx, float a, float x, float y, float z);
void matrixScale(Matrix* mtx, float x, float y, float z);
void matrixTranslate(Matrix* mtx, float x, float y, float z);
void matrixInvert(Matrix* restrict mi, Matrix* restrict mtxout);
void matrixMultiply(Matrix* out, Matrix* ma, Matrix* mb);
void matrixPerspective(Matrix* out, float* perspNorm, float fovy, float aspect, float near, float far);

#define MATRIX_GET(mtx, col, row) ((mtx)[(col)][(row)])

#endif

