#include <math/math.h>
#include <string.h>
#include "billboardtnode.h"

static void billboardtnodeProcess(BillboardTNode* billboard);

void billboardtnodeConstruct(BillboardTNode* billboard, const Pair* pairs) {

	tnodeConstruct(&billboard->tnode, NULL);
	billboard->tnode.node.type = NODE_BILLBOARD;
	billboard->tnode.Process = (void (*)(struct TNode*))billboardtnodeProcess;
	billboardConstruct(&billboard->billboard, pairs);
}

void billboardtnodeDestroy(BillboardTNode* billboard) {

	billboardDestroy(&billboard->billboard);
	tnodeDestroy(&billboard->tnode);
}

static void billboardtnodeProcess(BillboardTNode* billboard) {
	
	TNode* tnode = &billboard->tnode;
	TNode* parent = (TNode*)nodeGetParent(tnodeGetNode(tnode));
	if(parent) {
		Matrix* bbmtx = tnodeGetMatrix(tnode);
		Vector3f bbpos;
		vector3fSet(&bbpos, MATRIX_GET(*bbmtx, 3, 0), MATRIX_GET(*bbmtx, 3, 1), MATRIX_GET(*bbmtx, 3, 2));
		Vector3f newpos;
		mathTransformVector(&newpos, &bbpos, tnodeGetTransformedMatrix(parent));
		MATRIX_GET(*bbmtx, 3, 0) = newpos.x;
		MATRIX_GET(*bbmtx, 3, 1) = newpos.y;
		MATRIX_GET(*bbmtx, 3, 2) = newpos.z;
	}

	memcpy(tnodeGetTransformedMatrix(tnode), tnodeGetMatrix(tnode), sizeof(Matrix));
	tnodeReset(tnode);
}

