#include <sys/region.h>
#include "layer.h"

void layerConstruct(Layer* layer) {

	vec_Construct(&layer->vts, sizeof(MyVertex), ALIGN_4B);
	vec_Construct(&layer->faces, sizeof(Face), ALIGN_4B);
	layerSetMaterial(layer, NULL);
}

void layerDestroy(Layer* layer) {

	vec_Destroy(&layer->faces);
	vec_Destroy(&layer->vts);
}

inline void layerSetMaterial(Layer* layer, Material* material) {

	layer->material = material;
}

