#include "mesh.h"

void meshConstruct(Mesh* mesh, const Pair* pairs) {
	
	vec_Construct(&mesh->vpairs, sizeof(Pair), 0);
	vec_Construct(&mesh->layers, sizeof(Layer), 0);

	if(NULL == pairs)
		return;
	for(const Pair* pair = pairs; pair->mat; pair++) {
		vec_PushBack(&mesh->vpairs, pair);
	}
}

void meshDestroy(Mesh* mesh) {
	
	vec_Destroy(&mesh->layers);
	vec_Destroy(&mesh->vpairs);
}

