#include <sys/region.h>
#include "node.h"

void nodeConstruct(Node* node) {

	vec_Construct(&node->children, sizeof(Node*), ALIGN_DEFAULT);
	node->type = NODE_RAW;
	node->parent = NULL;
}

void nodeDestroy(Node* node) {

	vec_Destroy(&node->children);
}

void nodeAttach(Node* node, Node* child) {

	vec_PushBack(&node->children, &child);
	child->parent = node;
}

inline uint_t nodeGetNumChildren(const Node* node) {

	return vec_GetSize(&node->children);
}

inline Node* nodeGetParent(Node* node) {

	return node->parent;
}

inline Node* nodeGetChild(Node* node, uint_t i) {

	return *(Node**)vec_GetElement(&node->children, i);
}

inline void nodeIteratorConstruct(NodeIterator* iterator, Node* node) {

	stackConstruct(&iterator->stack, sizeof(iterator->i));
	iterator->node = node;
	nodeIteratorReset(iterator);
}

Node* nodeIteratorInc(NodeIterator* iterator) {

	Node* node;
i_believe_in_goto:	node = iterator->next;

	bool node_visited = iterator->i;

	uint_t n = nodeGetNumChildren(node);
	if(iterator->i < n) {

		iterator->next = nodeGetChild(node, iterator->i);
		iterator->i++;
		stackPush(&iterator->stack, &iterator->i);

		iterator->i = 0;

	} else {

		if(true == stackIsEmpty(&iterator->stack))
			return NULL;

		iterator->i = *(uint_t*)stackPop(&iterator->stack);
		iterator->next = nodeGetParent(node);
	}

	if(node_visited)
		goto i_believe_in_goto;

	return node;
}

inline void nodeIteratorReset(NodeIterator* iterator) {

	iterator->next = iterator->node;
	iterator->i = 0;
}

