#ifndef TNODE_H
#define TNODE_H

#include <math/matrix.h>
#include "node.h"

#define	MAX_NODES		256			/*  */
#define MATRIX_ALIGNMENT	4

typedef struct TNode {
	Node		node;
	Matrix*		mtx;
	Matrix*		resultMtxF;
	void		(*Process)(struct TNode*);
} TNode;

void tnodeConstruct(TNode* tnode, TNode* parent);
void tnodeDestroy(TNode* tnode);
Node* tnodeGetNode(TNode* tnode);
Matrix* tnodeGetMatrix(const TNode* tnode);
Matrix* tnodeGetTransformedMatrix(const TNode* tnode);
void tnodeReset(TNode* tnode);
void tnodeProcess(TNode* tnode);
void tnodeTransform(TNode* node, Matrix* mtx);

#endif	/* TNODE_H */

