#include <types.h>
#include "postproc.h"

static float k[] = {
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 0.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24
};

void postprocBlur_RGBA_5551(const Surface* surface_out, const Surface* surface) {
	int32_t i;
	uint16_t j;
	static uint16_t p[25];
	static uint16_t pr[25];
	static uint16_t pg[25];
	static uint16_t pb[25];
	static uint16_t pa[25];
	uint16_t r,g,b,a;
	float fr,fg,fb,fa;

	uint16_t* buf = surfaceGetData(surface);
	uint16_t* buf_o = surfaceGetData(surface_out);
	uint16_t width = surfaceGetWidth(surface);
	
	for(uint32_t n=0; n<surfaceGetPixelsNum(surface); n++) {
		uint32_t ofs = n - (width<<1);
		for(i=-2, j=0; i<=2; i++) {
			p[j] = buf[ofs-2];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs-1];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs+1];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs+2];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;

			ofs += width;
		}
		
		for(i=0, fr=fg=fb=fa=0.0f; i<25; i++) {
			fr += pr[i]*k[i];
			fg += pg[i]*k[i];
			fb += pb[i]*k[i];
			fa += pa[i]*k[i];
		}
		
		r = ((uint16_t)fr)&0xF800;
		g = ((uint16_t)fg)&0x07C0;
		b = ((uint16_t)fb)&0x003E;
		a = ((uint16_t)fa)&0x0001;
		
		((uint16_t*)buf_o)[n] = r|g|b|a;
	}
}

void postprocBlur(const Surface* surface_out, const Surface* surface) {
	switch(surfaceGetPixelFormat(surface)) {
		default:
			postprocBlur_RGBA_5551(surface_out, surface);
			break;
	}
}

