#include "stream.h"

void streamConstruct(Stream* stream, void* data, size_t size) {

	stream->data = data;
	stream->size = size;
	streamReset(stream);
}

void streamDestroy(Stream* stream) {

	if(stream) {}
}

inline void streamReset(Stream* stream) {

	stream->ofs = 0;
}

inline void* streamGetData(const Stream* stream) {

	return stream->data + stream->ofs;
}

#if 0
inline uint8_t* streamGetU8(Stream* stream) {

	uint8_t* ptr = (uint8_t*)(stream->data + stream->ofs);
	stream->ofs += sizeof(*ptr);

	return stream->ofs <= stream->size ? ptr : NULL;
}

inline uint16_t* streamGetU16(Stream* stream) {

	uint16_t* ptr = (uint16_t*)(stream->data + stream->ofs);
	stream->ofs += sizeof(*ptr);

	return stream->ofs <= stream->size ? ptr : NULL;
}

inline uint32_t* streamGetU32(Stream* stream) {

	uint32_t* ptr = (uint32_t*)(stream->data + stream->ofs);
	stream->ofs += sizeof(*ptr);

	return stream->ofs <= stream->size ? ptr : NULL;
}

inline float* streamGetFloat(Stream* stream) {

	float* ptr = (float*)(stream->data + stream->ofs);
	stream->ofs += sizeof(*ptr);

	return stream->ofs <= stream->size ? ptr : NULL;
}

inline void** streamGetPtr(Stream* stream) {

	void** ptr = (void**)(stream->data + stream->ofs);
	stream->ofs += sizeof(*ptr);

	return stream->ofs <= stream->size ? ptr : NULL;
}

inline void* streamGetT(Stream* stream, size_t size) {

	void* ptr = stream->data + stream->ofs;
	stream->ofs += size;

	return stream->ofs <= stream->size ? ptr : NULL;
}
#endif

inline void* streamExtract(Stream* stream, size_t size) {

	void* ptr = stream->data + stream->ofs;
	stream->ofs += size;

	return stream->ofs <= stream->size ? ptr : NULL;
}

