#ifndef STREAM_H
#define STREAM_H

#include <types.h>

typedef struct {
	uint8_t*	data;
	size_t		size;
	uint32_t	ofs;
} Stream;

void streamConstruct(Stream* stream, void* data, size_t size);
void streamDestroy(Stream* stream);
void streamReset(Stream* stream);
void* streamGetData(const Stream* stream);
#if 0
uint8_t* streamGetU8(Stream* stream);
uint16_t* streamGetU16(Stream* stream);
uint32_t* streamGetU32(Stream* stream);
float* streamGetFloat(Stream* stream);
void** streamGetPtr(Stream* stream);
void* streamGetT(Stream* stream, size_t size);
#endif
void* streamExtract(Stream* stream, size_t size);

#endif	/* STREAM_H */

