#include <abort.h>
#include <malloc.h>
#include <sys/region.h>
#include "displaylist.h"

DisplayList* displaylistNew(void) {

	DisplayList* dl = malloc(sizeof(DisplayList));
	if(NULL == dl) {
		abort();
	}
	displaylistConstruct(dl);
	
	return dl;
}

void displaylistConstruct(DisplayList* dl) {
	vec_Construct(&dl->gfx, sizeof(Gfx), ALIGN_8B);

	//dl->gpstart = ALIGN_ADR(malloc(ncmd*sizeof(Gfx) + 8), 3);	
	//dl->gpcurr = dl->gpstart;
	//dl->ncmd = ncmd;
	//dl->i = 0;
}

inline Gfx* dlGetHead(DisplayList* dl) {
	return vec_GetElement(&dl->gfx, 0);
}

inline uint16_t dlGetLength(const DisplayList* dl) {
	return vec_GetSize(&dl->gfx);
}

void dlResetCounter(DisplayList* dl) {
	vec_Reset(&dl->gfx);

	//dl->i = 0;
	//dl->gpcurr = dl->gpstart;
}

void dlAddCommand_(DisplayList* dl, Gfx cmd) {
	vec_PushBack(&dl->gfx, &cmd);

	//if(dl->i >= dl->ncmd)
	//	return;
	//*dl->gpcurr = cmd;
	//dl->gpcurr++;
	//dl->i++;
}

void dlAddCommands_(DisplayList* dl, Gfx cmd[], uint8_t n) {
	for(uint8_t i=0; i<n; i++) {
		dlAddCommand_(dl, cmd[i]);
	}
}

inline _Bool dlOverflowOccured(DisplayList* dl) {
	//return dl->i >= dl->ncmd;
	if(dl) {}
	return false;
}

