#include "region.h"

#define ALIGN_ADR(adr, align)	( (void*)(((uintptr_t)(adr) + (1<<(align)) - 1) & ~((1<<(align)) - 1)) )

static void* g_addr = (void*)0x80100000;

int regionInitialize() {
	return 0;
}

int regionConstruct(Region* region, RegionAlignment alignment, uint32_t bytes, uint32_t el_size) {
	if(NULL == region || 0 == bytes || 0 == el_size)
		return -1;

	region->addr = ALIGN_ADR(g_addr, alignment);
	region->alignment = alignment;
	region->bytes = bytes;
	region->el_size = el_size;

	g_addr = (uint8_t*)region->addr + bytes;
	if(g_addr >= (void*)0x80200000)
		return -1;

	return 0;
}

int regionDestruct(Region* region) {
	if(NULL == region)
		return -1;

	return 0;
}

void* regionAlloc(Region* region) {
	if(NULL == region)
		return NULL;

	if(region->el_size * region->n >= region->bytes)
		return NULL;

	void* ret = region->addr;
	*(uint8_t**)&region->addr += region->el_size;
	region->addr = ALIGN_ADR(region->addr, region->alignment);
	region->n++;

	return ret;
}

void* regionCAlloc(Region* region) {
	void* retval;
	if(NULL == (retval = regionAlloc(region)))
		return NULL;

	bzero(retval, region->el_size);

	return retval;
}

uint32_t regionGetElementSize(Region* region) {
	return region->el_size;
}

