#ifndef REGION_H
#define REGION_H

#include <types.h>

typedef enum RegionAlignment {
	ALIGN_1B = 0,
	ALIGN_2B = 1,
	ALIGN_4B = 2,
	ALIGN_8B = 3,
	ALIGN_16B = 4,
	ALIGN_32B = 5,
	ALIGN_64B = 6,
	ALIGN_DEFAULT = ALIGN_4B,
} RegionAlignment;

typedef struct Region {
	void*		addr;
	uint32_t	bytes;
	uint32_t	el_size;
	uint32_t	n;
	RegionAlignment	alignment;
} Region;

/* interface */
int regionInitialize();
int regionConstruct(Region* region, RegionAlignment alignment, uint32_t bytes, uint32_t el_size);
int regionDestruct(Region* region);
void* regionAlloc(Region* region);
void* regionCAlloc(Region* region);
uint32_t regionGetElementSize(Region* region);

#endif

