#include "surface.h"

void surfaceConstruct(Surface* surface, PixelFormat pixfmt, void* data, uint16_t width, uint16_t height) {
	surface->pixfmt = pixfmt;
	surface->data = data;
	surface->width = width;
	surface->height = height;
}

inline PixelFormat surfaceGetPixelFormat(const Surface* surface) {
	return surface->pixfmt;
}

inline void* surfaceGetData(const Surface* surface) {
	return surface->data;
}

inline uint16_t surfaceGetWidth(const Surface* surface) {
	return surface->width;
}

inline uint16_t surfaceGetHeight(const Surface* surface) {
	return surface->height;
}

inline uint32_t surfaceGetPixelsNum(const Surface* surface) {
	return surface->width*surface->height;
}

uint32_t surfaceGetSize(const Surface* surface) {
	switch(surfaceGetPixelFormat(surface)) {
		case PIXELFMT_RGBA_5551:
		case PIXELFMT_16:
			return surfaceGetPixelsNum(surface)*2;
		default:
			return 0;
	}
}

