#ifndef SURFACE_H
#define SURFACE_H

#include "stdlib/types.h"

typedef enum {
	PIXELFMT_RGBA_5551,
	PIXELFMT_16
} PixelFormat;

typedef struct {
	PixelFormat	pixfmt;
	void*		data;
	uint16_t	width;
	uint16_t	height;
} Surface;

void surfaceConstruct(Surface* surface, PixelFormat pixfmt, void* data, uint16_t width, uint16_t height);
PixelFormat surfaceGetPixelFormat(const Surface* surface);
void* surfaceGetData(const Surface* surface);
uint16_t surfaceGetWidth(const Surface* surface);
uint16_t surfaceGetHeight(const Surface* surface);
uint32_t surfaceGetPixelsNum(const Surface* surface);
uint32_t surfaceGetSize(const Surface* surface);

#endif	/* SURFACE_H */

