#include "texture.h"

void textureCopy(Texture* texture, const Texture* source) {

	*texture = *source;
}

void textureDestroy(Texture* texture) {

	if(texture) {}
}

inline uint32_t textureGetPixelCount(const Texture* texture) {

	return texture->width*texture->height;
}

inline uint16_t textureGetWidth(const Texture* texture) {

	return texture->width;
}

inline uint16_t textureGetHeight(const Texture* texture) {
	
	return texture->height;
}

inline uint8_t textureGetBytesPerPixel(const Texture* texture) {

	switch(textureGetFormat(texture)) {
		case TEXTURE_FMT_RGBA16:
			return 2;
		case TEXTURE_FMT_RGBA32:
			return 4;
		default:
			return -1;
	}
}

inline TextureFormat textureGetFormat(const Texture* texture) {

	return texture->fmt;
}

inline void* textureGetPixels(Texture* texture) {

	return texture->pixels;
}

inline const void* textureGetConstPixels(const Texture* texture) {

	return texture->pixels;
}

